if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_COMMENT_DELETE') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_COMMENT_DELETE
GO

if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_COMMENT_INSERT') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_COMMENT_INSERT
GO

if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_COMMENT_LIST') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_COMMENT_LIST
GO


SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO




CREATE   PROCEDURE KN3_BOARD_COMMENT_DELETE
	@strTableName		varchar(20),
	@strCode		varchar(20),
	@intSeq			integer,
	@Comment_intSeq	integer
AS

declare @rowcount int

DELETE FROM KN3_Board_Comment WHERE intSeq=@Comment_intSeq AND Board_strTable=@strTableName AND Board_strCode=@strCode AND Board_intSeq=@intSeq
	IF (@@ROWCOUNT > 0)
		EXECUTE('UPDATE '+@strTableName+' SET intCommentCount=intCommentCount-1 WHERE strCode='''+@strCode+''' AND intSeq='+@intSeq)




GO


SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE  PROCEDURE KN3_BOARD_COMMENT_INSERT
	@strTableName	varchar(20),
	@strCode	varchar(20),
	@intSeq		integer,
	@strId		varchar(20),
	@strName	varchar(20),
	@strContent	varchar(200)
AS


INSERT INTO KN3_Board_Comment(Board_strTable, Board_strCode, Board_intSeq, strId, strName, strContent)
VALUES(@strTableName, @strCode, @intSeq, @strId, @strName, @strContent)

EXECUTE('UPDATE '+@strTableName+' SET intCommentCount=intCommentCount+1 WHERE strCode='''+@strCode +''' AND intSeq='+ @intSeq)



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO




CREATE   PROCEDURE KN3_BOARD_COMMENT_LIST
	@strTableName	varchar(20),
	@strCode	varchar(20),
	@intSeq		integer
AS


SELECT intSeq, strId, strName, strContent, dateRegDate FROM KN3_Board_Comment WHERE Board_strTable=@strTableName AND Board_strCode=@strCode AND Board_intSeq=@intSeq





GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

