if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_TYPE01_COUNT') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_TYPE01_COUNT
GO


if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_TYPE01_DELETE') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_TYPE01_DELETE
GO


if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_TYPE01_EDIT') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_TYPE01_EDIT
GO


if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_TYPE01_INSERT') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_TYPE01_INSERT
GO


if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_TYPE01_LIST') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_TYPE01_LIST
GO


if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_TYPE01_REPLY') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_TYPE01_REPLY
GO


if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_TYPE01_SHOW') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_TYPE01_SHOW
GO


if exists (select * from dbo.sysobjects where id = object_id(N'KN3_BOARD_TYPE01_SUBLIST') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure KN3_BOARD_TYPE01_SUBLIST
GO





SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


create procedure KN3_BOARD_TYPE01_COUNT
	@strCode	varchar(20)
as

	SELECT intSeqIndex, intSeqCount FROM KN3_Board_Type01_Index WHERE strCode=@strCode


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO






CREATE    PROCEDURE KN3_BOARD_TYPE01_DELETE
	@strCode	varchar(20),
	@intSeq		integer,
	@strId		varchar(20),
	@strName	varchar(20),
	@Result		varchar(20)	OUTPUT
AS

	DECLARE @tmp_strId	varchar(20)
	DECLARE @intSeqIndex	integer
	DECLARE @intThread	integer
	DECLARE @intReplyCount	integer
	DECLARE @strDeleteMsg	varchar(1000)

	SET @Result='FALSE'
	SET @strDeleteMsg = @strName +'['+ @strId +']Կ  Խù  Ǿϴ.'

	-- ⺻   
	SELECT @intSeqIndex=intSeqIndex, @tmp_strId=strId, @intThread=intThread  FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq

	-- , ۼ ̵ 񱳿  ϰ쿡 
	IF ((@tmp_strId=@strId) OR ((@strId='Admin') AND (@strName='')))
		BEGIN
			--   üũ (ϰ쿡  üũ  ó
			IF ((@intThread - (((@intThread/100)*100)+99)) = 0)
				BEGIN
					--    üũ
					SELECT @intReplyCount=COUNT(*) FROM KN3_Board_Type01 WHERE intThread < @intThread AND intThread >= (@intThread/100)*100

					--   ( )
					IF (@intReplyCount=0)
						BEGIN
							SET @Result='DELETE'
							DELETE FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
							UPDATE KN3_Board_Type01_Index SET intSeqCount=intSeqCount-1 WHERE strCode=@strCode AND intSeqIndex=@intSeqIndex
							DELETE FROM KN3_Board_Comment WHERE Board_strTable='KN3_Board_Type01' AND Board_strCode=@strCode AND Board_intSeq=@intSeq
						END
					--   (Ʈ)
					ELSE
						BEGIN
							SET @Result='UPDATE'
							UPDATE KN3_Board_Type01 SET bitDeleteCheck=1, strSubject=@strDeleteMsg, strContentSort=@strDeleteMsg WHERE strCode=@strCode AND intSeq=@intSeq
						END
				END
			-- 亯϶ ׳ 
			ELSE
				BEGIN
					SET @Result='DELETE'
					DELETE FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
					UPDATE KN3_Board_Type01_Index SET intSeqCount=intSeqCount-1 WHERE strCode=@strCode AND intSeqIndex=@intSeqIndex
					DELETE FROM KN3_Board_Comment WHERE Board_strTable='KN3_Board_Type01' AND Board_strCode=@strCode AND Board_intSeq=@intSeq
				END

		END

	
	






GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO




CREATE  PROCEDURE KN3_BOARD_TYPE01_EDIT
	@strCode	varchar(20),
	@intSeq		integer,
	@strName	varchar(20),
	@strSubject	varchar(100),
	@strContentSort	varchar(200),
	@strContent1	varchar(8000),
	@strContent2	varchar(8000),
	@strContent3	varchar(8000),
	@strContent4	varchar(8000)
AS

	DECLARE @intContentLength	integer
	DECLARE @binContentPoint	binary(16)

	--// Խù 
	UPDATE KN3_Board_Type01 SET strName=@strName, strSubject=@strSubject, strContentSort=@strContentSort, strContent=@strContent1 WHERE strCode=@strCode AND intSeq=@intSeq

	--// Խù  8000byte ̻϶ ó
	IF (@strContent2='' OR @strContent2 IS NULL)
		RETURN

		SET @intContentLength=DATALENGTH(@strContent1)
		SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
		UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent2

	--// Խù  16000byte ̻϶ ó
	IF (@strContent3='' OR @strContent3 IS NULL)
		RETURN

		SET @intContentLength=@intContentLength+DATALENGTH(@strContent2)
		SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
		UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent3

	--// Խù  24000byte ̻϶ ó
	IF (@strContent4='' OR @strContent4 IS NULL)
		RETURN

		SET @intContentLength=@intContentLength+DATALENGTH(@strContent3)
		SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
		UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent4





GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO



CREATE  PROCEDURE KN3_BOARD_TYPE01_INSERT
	@strCode	varchar(20),
	@strId		varchar(20),
	@strName	varchar(20),
	@strSubject	varchar(100),
	@strContentSort	varchar(200),
	@strContent1	varchar(8000),
	@strContent2	varchar(8000),
	@strContent3	varchar(8000),
	@strContent4	varchar(8000),
	@strIpAddr	varchar(15)
AS

	DECLARE @intSeq	integer
	DECLARE @intThread	integer
	DECLARE @intSeqIndex	integer
	DECLARE @intSeqCount	integer
	DECLARE @intContentLength	integer
	DECLARE @binContentPoint	binary(16)

	--// ۹ȣ  
	SELECT @intSeq=isNULL(MAX(intSeq),0)+1 FROM KN3_Board_Type01 WHERE strCode=@strCode

	--// θ ȣ 
	SET @intThread = (@intSeq * 100) + 99

	--// ε ȣ  
	SELECT TOP 1 @intSeqIndex=isNULL(intSeqIndex,0), @intSeqCount=isNULL(intSeqCount,0) FROM KN3_Board_Type01_Index WHERE strCode=@strCode
		SET @intSeqCount=IsNull(@intSeqCount, 0)
		SET @intSeqIndex=IsNull(@intSeqIndex, 1)

	--// ؽ ȣ Խù ˻   ο
	IF (@intSeqCount > 5000)
		SET @intSeqIndex=@intSeqIndex+1

	--// ε ̺ Ʈ/μƮ
	UPDATE KN3_Board_Type01_Index SET intSeqCount=intSeqCount+1 WHERE strCode=@strCode AND intSeqIndex=@intSeqIndex
		IF (@@ROWCOUNT=0)
			INSERT INTO KN3_Board_Type01_Index(strCode, intSeqIndex, intSeqCount) VALUES (@strCode, @intSeqIndex, 1)

	--// Խù 
	INSERT INTO KN3_Board_Type01(strCode, intSeq, intSeqIndex, intThread, intDepth, strIpAddr, intReadCount, intCommentCount, bitDeleteCheck, strId, strName, strSubject, strContentSort, strContent) VALUES (@strCode, @intSeq, @intSeqIndex, @intThread, 0, @strIpAddr, 0, 0, 0, @strId, @strName, @strSubject, @strContentSort, @strContent1)

	--// Խù  8000byte ̻϶ ó
	IF (@strContent2='' OR @strContent2 IS NULL)
		RETURN

		SET @intContentLength=DATALENGTH(@strContent1)
		SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
		UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent2

	--// Խù  16000byte ̻϶ ó
	IF (@strContent3='' OR @strContent3 IS NULL)
		RETURN

		SET @intContentLength=@intContentLength+DATALENGTH(@strContent2)
		SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
		UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent3

	--// Խù  24000byte ̻϶ ó
	IF (@strContent4='' OR @strContent4 IS NULL)
		RETURN

		SET @intContentLength=@intContentLength+DATALENGTH(@strContent3)
		SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
		UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent4




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO







CREATE     procedure KN3_BOARD_TYPE01_LIST
	@strCode		varchar(20),
	@intDividePageList	integer,
	@intTopCount		integer,
	@intBoardIndex_Start	integer,
	@intBoardIndex_End	integer
AS

	DECLARE @strSqlQuery1	varchar(2000)
	DECLARE @strSqlQuery2	varchar(2000)

	SET @strSqlQuery1 = 'SELECT TOP '+str(@intDividePageList)+' intSeq, intDepth, CASE WHEN DATALENGTH(strSubject)>66 THEN CONVERT(VARCHAR(66),strSubject)+''...'' ELSE strSubject END AS strSubject, CASE WHEN DATALENGTH(strName)>8 THEN CONVERT(VARCHAR(8),strName) ELSE strName END AS strName, dateRegDate, intReadCount, intCommentCount, bitDeleteCheck FROM KN3_Board_Type01 WHERE strCode='''+@strCode+''''
	IF (@intBoardIndex_Start = @intBoardIndex_End)
		SET @strSqlQuery1 = @strSqlQuery1 + ' AND intSeqIndex='+str(@intBoardIndex_Start)
	ELSE
		SET @strSqlQuery1 = @strSqlQuery1 + ' AND (intSeqIndex='+str(@intBoardIndex_Start)+' OR  intSeqIndex='+str(@intBoardIndex_End) +')'
	SET @strSqlQuery2 = ' AND intSeq NOT IN (SELECT TOP '+str(@intTopCount)+' intSeq FROM KN3_Board_Type01 WHERE strCode='''+@strCode+''' AND intSeqIndex='+str(@intBoardIndex_Start)+')'

	EXECUTE(@strSqlQuery1 + @strSqlQuery2)







GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO




CREATE  PROCEDURE KN3_BOARD_TYPE01_REPLY
	@strCode	varchar(20),
	@intSeqIndex	integer,
	@intDepth	integer,
	@intThread	integer,
	@strId		varchar(20),
	@strName	varchar(20),
	@strSubject	varchar(100),
	@strContentSort	varchar(200),
	@strContent1	varchar(8000),
	@strContent2	varchar(8000),
	@strContent3	varchar(8000),
	@strContent4	varchar(8000),
	@strIpAddr	varchar(15),
	@result		varchar(20)	OUTPUT
AS

	DECLARE @intSeq		integer
	DECLARE @intContentLength	integer
	DECLARE @binContentPoint	binary(16)
	DECLARE @intChkReplyCount	integer
	
	SET @result = 'FALSE'

	SELECT @intChkReplyCount = COUNT(*) FROM KN3_Board_Type01 WHERE intThread < ((@intThread/100)+1)*100 AND intThread > ((@intThread/100)-1)*100

	IF (@intChkReplyCount < 99)
	     BEGIN
		SET @result = 'TRUE'

		--// ۹ȣ  
		SELECT @intSeq=isNULL(MAX(intSeq),0)+1 FROM KN3_Board_Type01 WHERE strCode=@strCode
	
		--// ε ̺ Ʈ/μƮ
		UPDATE KN3_Board_Type01_Index SET intSeqCount=intSeqCount+1 WHERE strCode=@strCode AND intSeqIndex=@intSeqIndex
	
		--//  ȣ  ѵ intThread ȣ -1  
		UPDATE KN3_Board_Type01 SET intThread = intThread -1 WHERE intThread < @intThread AND intThread > ((@intThread /100)*100 -1)
	
		--// Է± intThread  -1, intDepth +1 
		SET @intThread = @intThread -1
		SET @intDepth = @intDepth + 1
		
		--// Խù 
		INSERT INTO KN3_Board_Type01(strCode, intSeq, intSeqIndex, intThread, intDepth, strIpAddr, intReadCount, intCommentCount, bitDeleteCheck, strId, strName, strSubject, strContentSort, strContent) VALUES (@strCode, @intSeq, @intSeqIndex, @intThread, @intDepth, @strIpAddr, 0, 0, 0, @strId, @strName, @strSubject, @strContentSort, @strContent1)
	
		--// Խù  8000byte ̻϶ ó
		IF (@strContent2='' OR @strContent2 IS NULL)
			RETURN
	
			SET @intContentLength=DATALENGTH(@strContent1)
			SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
			UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent2
	
		--// Խù  16000byte ̻϶ ó
		IF (@strContent3='' OR @strContent3 IS NULL)
			RETURN
	
			SET @intContentLength=@intContentLength+DATALENGTH(@strContent2)
			SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
			UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent3
	
		--// Խù  24000byte ̻϶ ó
		IF (@strContent4='' OR @strContent4 IS NULL)
			RETURN
	
			SET @intContentLength=@intContentLength+DATALENGTH(@strContent3)
			SELECT @binContentPoint=TEXTPTR(strContent) FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq
			UPDATETEXT KN3_Board_Type01.strContent @binContentPoint @intContentLength null @strContent4

	     END



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO









CREATE      procedure KN3_BOARD_TYPE01_SHOW
	@strCode		varchar(20),
	@intSeq			integer
AS
	
	SET NOCOUNT ON	--// Ʈ  ޽  ϱ 

	--//      +1 ֱ
		UPDATE KN3_Board_Type01 SET intReadCount=intReadCount+1 WHERE strCode=@strCode AND intSeq=@intSeq

	SET NOCOUNT OFF

	--//    
		SELECT intSeqIndex, intThread, intDepth, strIpAddr, dateRegDate, strId, strName, bitDeleteCheck, strSubject, strContent, intCommentCount FROM KN3_Board_Type01 WHERE strCode=@strCode AND intSeq=@intSeq






GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO












CREATE       procedure KN3_BOARD_TYPE01_SUBLIST
	@strCode		varchar(20),
	@intSeqIndex		integer,
	@intThread		integer
AS

DECLARE @intSeq varchar(1000)

SET @intSeq=''

	SET NOCOUNT ON

		SELECT TOP 1 @intSeq = @intSeq + ','+convert(varchar(10),intSeq) FROM KN3_Board_Type01 WHERE strCode=@strCode AND (intSeqIndex=@intSeqIndex OR intSeqIndex=@intSeqIndex+1) AND intThread>=(((@intThread/100)+1)*100) AND  intDepth=0 ORDER BY intSeq

		SELECT  @intSeq = @intSeq + ','+convert(varchar(10),intSeq) FROM KN3_Board_Type01 WHERE  strCode=@strCode AND (intSeqIndex=@intSeqIndex) AND  intThread<(((@intThread/100)+1)*100) AND intThread>((@intThread/100)*100)

		SELECT TOP 1 @intSeq = @intSeq + ','+convert(varchar(10),intSeq) FROM KN3_Board_Type01 WHERE strCode=@strCode AND (intSeqIndex=@intSeqIndex OR intSeqIndex=@intSeqIndex-1) AND  intThread<((@intThread/100)*100) AND  intDepth=0

		SET @intSeq = SUBSTRING(@intSeq, 2, LEN(@intSeq))

	SET NOCOUNT OFF

	exec('SELECT intSeq, intThread, intDepth, strSubject FROM KN3_Board_Type01 WHERE strCode='''+@strCode+''' AND intSeq IN ('+@intSeq+')')


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

